; $Id: launch_opan.pro,v 1.3 2005/01/31 17:29:03 dimeo Exp $
;###############################################################################
;
; NAME:
;  LAUNCH_OPAN
;
; PURPOSE:
;  Program launcher for OPAN from DAVE.PRO.
;
; CATEGORY:
;  DAVE, Data Analysis, PAN, curve fitting
;
; AUTHOR:
;   Robert M. Dimeo, Ph.D.
;   NIST Center for Neutron Research
;   100 Bureau Drive
;   Gaithersburg, MD 20899
;   Phone: (301) 975-8135
;   E-mail: robert.dimeo@nist.gov
;   http://www.ncnr.nist.gov/staff/dimeo
;
; LICENSE:
;  The software in this file is written by an employee of
;  National Institute of Standards and Technology
;  as part of the DAVE software project.
;
;  The DAVE software package is not subject to copyright protection
;  and is in the public domain. It should be considered as an
;  experimental neutron scattering data reduction, visualization, and
;  analysis system. As such, the authors assume no responsibility
;  whatsoever for its use, and make no guarantees, expressed or
;  implied, about its quality, reliability, or any other
;  characteristic. The use of certain trade names or commercial
;  products does not imply any endorsement of a particular product,
;  nor does it imply that the named product is necessarily the best
;  product for the stated purpose. We would appreciate acknowledgment
;  if the DAVE software is used of if the code in this file is
;  included in another product.
;
;###############################################################################
pro launch_opan,event
widget_control,event.top,get_uvalue = pState
thisEvent = tag_names(event,/structure_name)
case thisEvent of
'WIDGET_BUTTON': $
  begin
   ; Get the current DAVE pointer
   file_path = (*!dave_defaults).workDir
   if n_elements(*(*(*(*pState).davePtr).dataStrPtr).commonStr.histPtr) $
      ne 0 then begin
       davePtr = (*pState).davePtr
       o = obj_new('opan',notifyId = [event.id,event.top], $
                         group_leader = event.top, $
                        davePtr = davePtr, $
                        workDir = file_path, $
                        dataDir = file_path)
    endif else begin
       o = obj_new('opan',notifyId = [event.id,event.top], $
                         group_leader = event.top, $
                        workDir = file_path, $
                        dataDir = file_path)
    endelse
    (*(*pState).extraPtr).panInfo.panContainer->add,o
  end
'WIDGET_TREE_SEL': $
  begin
   ; Get the current DAVE pointer
   file_path = (*!dave_defaults).workDir
   if n_elements(*(*(*(*pState).davePtr).dataStrPtr).commonStr.histPtr) $
      ne 0 then begin
       davePtr = (*pState).davePtr
       o = obj_new('opan',notifyId = [event.id,event.top], $
                         group_leader = event.top, $
                        davePtr = davePtr, $
                        workDir = file_path, $
                        dataDir = file_path)
    endif else begin
       o = obj_new('opan',notifyId = [event.id,event.top], $
                         group_leader = event.top, $
                        workDir = file_path, $
                        dataDir = file_path)
    endelse
    (*(*pState).extraPtr).panInfo.panContainer->add,o
  end
'OPANEVENT': $
  begin
    obj = event.object  ; This is the object that just quit
    (*(*pState).extraPtr).panInfo.panContainer->remove,obj
   obj_destroy,obj
  end
else:
endcase
return
end